os = reaper.GetOS()
if "Win" == string.match(os,"(Win)") then
   package.cpath = package.cpath .. ";"..reaper.GetResourcePath() .."/UserPlugins/?.dll"
else
   package.cpath = package.cpath .. ";"..reaper.GetResourcePath() .."/UserPlugins/?.dylib"
end
require("reaper_AZSTOKE_SILVER")

function Msg(param)
   reaper.ShowConsoleMsg(tostring(param).."\n")
end

trackNameList = {"pl0000","pl1000","pl2000","pl3000","pl4000","pl5000"}
trackColorList = {33554304,33521664,25165824,16777471,21004543,20988032}


--Get Master Select Track 
masterTrack = reaper.AZ_GetTrackItemSelect(0,0,1)
_,masterName = reaper.AZ_GetTrackItemName(masterTrack)
_,masterDepth = reaper.AZ_GetTrackItemDepth(masterTrack)

for i, value in pairs(trackNameList) do
   if masterName == trackNameList[i] then
      reaper.AZ_SetTrackItemColor(masterTrack,trackColorList[i])
      masterColor = trackColorList[i]
   end
end

--Get Master Track Children
_,childList,masterChildCount = AZ_SILVER.AZ_GetTrackItemChildList(masterTrack)

childInfoList = {}
for i, value in pairs(childList) do
    childInfoList[i] = {}
    _,childInfoList[i]["TrackName"]= reaper.AZ_GetTrackItemName(value)
    reaper.AZ_SetTrackItemColor(value,masterColor)
end

--delet trackNameList & trackBaseList create 
_,trCount = reaper.AZ_GetTrackCountSelect(0,0)
deletIDList = {}
idCount = 0

for i = 0,trCount-1 do
    _,name = reaper.AZ_GetTrackIdName(0,i)
    for i, value in pairs(trackNameList) do
        if name == value then
           idCount = idCount + 1
           deletIDList[idCount] = i
        end
    end
end

table.sort(deletIDList,function(a,b) return (a>b)end)

for i = 1,idCount do
    table.remove(trackNameList,deletIDList[i])
    table.remove(trackColorList,deletIDList[i])
end

--InsertTrack
for i, value in pairs(trackNameList) do
    _,count = reaper.AZ_GetTrackCountSelect(0,0)
    track = reaper.AZ_InsertTrackId(0,count)
    reaper.AZ_SetTrackItemName(track,value)
    reaper.AZ_SetTrackItemDepth(track,masterDepth)
    reaper.AZ_SetTrackItemColor(track,trackColorList[i])
   
    for e = 1,masterChildCount do
        childTrack = reaper.AZ_InsertChildTrack(track)
        reaper.AZ_SetTrackItemName(childTrack,childInfoList[e].TrackName)
        reaper.AZ_SetTrackItemColor(childTrack,trackColorList[i])
    end
end



